/*
	AsciiToHetroCmd.h - convert ascii to Csound heterodyne analysis file format

	Will Eighteen, 2006: will@opaline.demon.co.uk
*/

#ifndef ASCIITOHETROCMD_H
#define ASCIITOHETROCMD_H

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


#define BUFSIZE 1024


class FileAccess;


class AsciiToHetroCmd : public BreakCmd
{
	public:
		AsciiToHetroCmd ( char *, int, char *, char * );
		virtual ~AsciiToHetroCmd();
		char *source() { return _srcFile; };
		char *target() { return _dstFile; };
		int error() { return _error; }

	protected:
		void doCommand();
		
	private:
		char _srcFile[BUFSIZE];
		char _dstFile[BUFSIZE];
		FileAccess *_in;
		FileAccess *_out;
		int _once, _percentDone, _error;
		int _intSize, _numInts;
		short int _num[0, 1];
};

#endif
