/*
	CreateSpatialScoreCmd.h - write spatialisation score/orchestra files for csound

	Will Eighteen, 2001: will@opaline.demon.co.uk
*/

#ifndef CREATESPATIALSCORECMD_H
#define CREATESPATIALSCORECMD_H


#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif

#include "NewSpatialTemplateCmd.h"


class CreateSpatialScoreCmd : public BreakCmd
{
	public:
		CreateSpatialScoreCmd ( char *, int, unsigned int, SpatialPak * );
		virtual const char *const className() { return ( "CreateSpatialScoreCmd" ); }
		~CreateSpatialScoreCmd();
		char *error() { return _error; }
		
	protected:
		void doCommand();

	private:
		int preCreate();
		void postCreate();
		void writeHeader();
		void writeFooter();
		void writeOrchFile();

		FileAccess *_target;
		SpatialPak *_spatialPak;
		SpatialPak *_scoreSpatialPak;
		char _error[1024];
		char _formatString[64];
		int _percentDone;
		int _once;
		long _timeout, _sampleRate;
		long _start, _end;
		unsigned int _waveNum;
		float _skipTime;
		unsigned long _totalSamples;
		unsigned long _processedSamples;
		unsigned long _numData;
		unsigned long _numTSamples;
		unsigned long _maxTemplateSize;

};

#endif
