/*
	FloatToIntCmd.h - convert floating-point to integer format

	Will Eighteen, 2000: will@opaline.demon.co.uk             
*/                                                                             

#ifndef FLOATTOINTCMD_H
#define FLOATTOINTCMD_H

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


#define BUFSIZE 1024


class FileAccess;


class FloatToIntCmd : public BreakCmd
{
	public:
		FloatToIntCmd ( char *, int, char *, char * );
		virtual ~FloatToIntCmd();
		char *source() { return _srcFile; }
		char *target() { return _dstFile; }
		int error() { return _error; }
		void offset ( int num ) { _offset = num; }
		void scale ( int num ) { _scale = num; }

	protected:
		void doCommand();
		
	private:
		char _srcFile[BUFSIZE];
		char _dstFile[BUFSIZE];
		FileAccess *_in;
		FileAccess *_out;
		float _fValue;
		int _once, _percentDone, _iValue, _error, _offset, _scale;
};

#endif
