/*
	OptionsHelpCmd.cc

	Will Eighteen, 2006: will@opaline.demon.co.uk
*/

#include "OptionsHelpCmd.h"
#include "Application.h"
#include <TextEdit.h>


OptionsHelpCmd::OptionsHelpCmd ( const char *name, int active ) :  NoUndoCmd ( name, active )
{
	_editRealised = FALSE;
}


OptionsHelpCmd::~OptionsHelpCmd()
{
	// empty
}


void OptionsHelpCmd::doCommand()
{
	if (_editRealised == TRUE )
		return;

	_edit = new TextEdit ( ( char * ) name(), TRUE, &OptionsHelpCmd::okCallback, &OptionsHelpCmd::cancelCallback, ( void * ) this );	
	_edit->setRows ( 19 );
	_edit->setColumns ( 70 );
	_editRealised = TRUE;
	_edit->execute();
	_edit->setText ( "Menu button help follows the application button \
layout.\n\n\nOptions / System control\nPops up a control panel with toggle \
buttons allowing modification of the behaviour of the mixer and of mode of \
reporting of the application.\n\nOptions / System Control / Time sync.\nAllows \
linking of templates to wave files so that selected regions in one are \
reflected in the other, 'OFF' disables this synchronisation; template and \
wave files' region selections are independent. 'ON' causes a toggle button \
to replace the 'Sync. mode disabled' message displayed when Time sync. is \
set to OFF. This controls whether the wave is synchronised to the template \
(selections made in the wave file cause the corresponding region of the \
template file to be highlighted), or the template synchronised to the wave \
(selection of a region in the template file causes the corresponding section \
of the wave file to be highlighted).\nSince during mixdown the gain and pan \
values for a track are dictated by the contents of its template files \
(unless global values of gain and pan have been selected in 'New Mix'), \
this means that the part of a template file governing the mix parameters \
of a particular part of a wave file can be located with ease from the wave \
and conversely, the part of a wave file which is affected by the template \
parameters can be readily found from the template. This applies even when \
the size of template and wave files do not correspond.\n\nOptions / System \
control / Sync. selections\nIn this mix mode, any selections existing in the \
mix waves will be synchronised so they start mixdown simultaneously. This \
allows correction if some tracks have a lead-in time which differs from others \
and saves having to edit the files themselves. If a loaded track does not \
have a selection, then the entire track will be mixed down.\nNote that this \
option disables 'MixToCurrentWave'.\n\nOptions / System \
control / MixToCurrentWave\nIf this is enabled, then the mixdown will be \
governed by the selection in the current wave (see Options/Wave control). All \
selections in other files will be ignored, and only those regions \
corresponding to the selection in the current wave will be mixed.\nNote that \
this option disables 'Sync. selections'.\n\nOptions / System control / Enable \
remix\nIf the mixdown produces an output which is overrange for the number of \
bits specified (in Options / File / Wave parameters) and this button is \
depressed then remixing occurs with the output right-shifted so the final \
result occupies the default number of bits (currently only 16-bit format is \
supported). Although some detail is lost, overall amplitude dynamics are \
preserved.\n\nOptions / System control / Enable message popups\nMessages have \
an informative function, emulating another well-known operating system's \
habit of confirming actions taken. If this is turned off, no such confirmation \
will be given (default Unix-type behaviour: if there isn't a problem the \
operation succeeded). Messages can be disabled once familiarity with \
Mixwave's behaviour and operation has been gained.\n\nOptions / System control \
/ Enable warning popups\nThis is a more serious level of information, \
reporting problems of which the user might be unaware. This option is probably \
best left enabled.\nNote that errors which occur are always reported; such \
messages cannot be disabled.\n\nOptions / System control / Save on exit\nThis \
allows mixwave to preserve the current state of its non-mix settings \
(contents of dialogue boxes and the settings in the system control menu \
itself) when 'File / Exit' closes the application. They are restored on next \
use. If the 'Save on exit' button is not depressed, then the state of those \
options which have not been altered during current use of the \
application will be restored instead.\n\nOptions / System control / Quit\n\
Pops down the system control menu, as does WM-close (title bar 'X').\n\n\n\
Options / Wave control\nIf no wave files have been loaded this button is \
inactive, otherwise a menu of loaded waves appears, each with a pair of \
buttons. If a selection has been made in the wave viewer for the file named \
on the right-hand button then the left-hand button allows the mix for that \
track to be toggled between 'Region' (i.e. the selected region) or 'All' \
(the entire track). This determines whether the whole or part of a track is \
used during mixdown. If no selections have been made in the track named, the \
left button is inactive and 'All' is displayed.\nDepressing one of the \
right-hand buttons makes the named track the current wave, displayed at \
the top of the WaveControl popup. This is of relevance to the 'Options / System \
control / MixToCurrent' button. MixToCurrent uses the current wave specified \
to force selection of a region in the current wave file on all other files in \
the mix. When mixdown is activated, only those portions of the loaded files \
corresponding to the region selected in the current wave will be used, \
regardless of any selections which may have been made in the other waves \
loaded. If MixToCurrent is enabled and there is no selection in the current \
wave then mixdown uses the whole length of the tracks.\n\n\nOptions / Directory \
\nSpecifies the default directory mixwave uses as the destination for the \
stereo mixdown and for storage of intermediate files (of which there may be \
quite a few, depending on the operation performed). Specifying a location \
here keeps them out of the way and in one place.\n\n\nOptions / Mix\nSpecifies \
default parameters particular to the mixdown process\n\nOptions / Mix \
/ Mix parameters\nActivates a dialogue box popup in which default values \
of gain and pan used for track mixdown are specified. These default values,\
gain 1 and pan 0.5, are applied to each track mixed unless they have been \
specified otherwise in 'New / Mix'. By default tracks are mixed with \
amplitude that of the recorded track and panned to centre (unless the \
dialogue box values are changed).\n\nOptions / Mix / Mix buffer size\n\
This governs the memory usage of the mixer. Tracks will be mixed (and loaded \
in blocks of this size (in bytes). A larger setting will enable more of each \
track to be read into memory, allowing faster mixdown, but response of the \
application may become sluggish, since the mixer is in an internal loop \
whilst the samples occupying the specified space are mixed.\n\n\nOptions \
/ File / Wave parameters\nProduces a popup dialogue box specifying the \
default header parameters for tracks to be mixed. It also specifies the \
header for new waves. The defaults are\n\n<number of bits per sample>,\n<sample \
rate (in Hz.)>,\n<number of channels>,\n<default file size (bytes)>\n\nAt \
present only 16-bit wave files are supported. The sample rate can be any \
valid number depending on the sample rate of the track when recorded. Single-\
channel (mono) files are specified by default: mixwave only deals with mono \
tracks, but the mixed output file is specified as stereo regardless of what \
is set here - these values only govern loaded tracks and new files). The \
final parameter governs the size of new files (empty unless otherwise defined \
here). Default 16,44100,1,0.\n\nOptions / File / Template size\nThis determines \
the number of data items in a newly created template file. It applies to \
both 'File / New / Template' options and 'File / New / Template / Spatial'.\n\
The purpose of this is to allow a relatively small sized template to control \
a length wave track. The number of data points should be considered in regard \
to the level of resolution required: if this is the same as the number of \
wave samples, then there can be a different value for gain, pan (and in the \
case of spatial templates, reverb and other features) for every wave sample.\
It is theoretically possible to adjust gain or pan for every sample. Obviously \
this is of little use and results in huge template files. The number of data \
points should be chosen to allow a degree of control which results in a \
smooth-sounding transition whilst minimising the size of the template used. \
This is particularly important in the case of spatialisation, where up to 16 \
separate templates may be used to control the process. Generally, a time value \
of 1/50 sec. should be sufficient to ensure smooth transitions, giving a \
template size for a 3-minute track of 180 secs. at 50 template data points \
per second, i.e. a template size of 9000. In practice, if large changes in \
template values over a short time period are not required, this could be \
reduced tenfold.\n\n\nOptions / \
Display\nGives a menu which allows the number format used, magnitude range of \
files displayed in the viewer and size of the viewer window to be \
determined\n\nOptions / Display / INT precision\nSpecifies number of digits \
displayed in the appropriate viewer data boxes and also governs the maximum \
number of digits allowed during file writes. Default 10.\n\nOptions / Display / FP \
precision\nSpecifies the number of digits displayed after the decimal point \
in appropriate viewer data boxes and also governs the precision of numbers \
written to output files. Note that a value of zero here denotes that only the \
integer part of floating-point numbers will be used or written. It is mostly \
helpful for governing the resolution of ascii data files. Default 5.\n\nOptions / \
Display / View size\nActivates a popup specifying the height and width of \
the wave viewer/editor window. The default values given are correct for \
the positioning of text boxes in the viewer frame for the above values \
of INT and FP precision. If these latter are changed, the text box size \
changes and the viewer window may need to be resized to be aesthetically \
satisfactory.\n\nOptions / Display / INT range\nThe minimum and maximum \
values specified here govern the magnitude of numbers which will fit into \
any given window. The defaults are maximum and minimum for a 16-bit signed \
wave file. These values also govern the range of amplitudes of templates, \
both displayed and created. Use of signed values gives a viewer window which \
has zero positioned in the centre of the view; use of positive values with \
minimum zero gives a view where zero is positioned at the bottom of the view \
window.Default -32768,32767.\n\nOptions / Display / FP range\nAs above, values here govern the \
magnitude of displayed floating-point format files and also the value range \
allowed to newly created files. This is a particularly important feature \
for mixer and and gain templates, both of which must be floating-point \
format files. Pan templates have values in the range <0,1>, the extremes \
indicating either left or right channel, and gain templates values in the \
range <0,n> where n may greater than 1 (amplification). Before creating new \
templates for gain and pan, ensure the correct number range is set in this \
dialogue box.Default -1,1.\n\nNote: the comments above regarding number range of integer \
and floating-point files are also relevant to spatial templates.\n\n\nOptions \
/ Convert\nAllows specification of an offset and scale used by the ''Edit / \
Convert' file converters to modify input values before output is written.\n\n\
Options  Convert / <type> to Int\nSpecifies offset and scale values applied \
when files of non-integer type are converted to integer format, such that the \
resulting integer is of magnitude <input_value>+offset*scale.\n\nOptions \
/ Convert / <type> to Float\nSpecifies offset and scale values applied \
when files of non-f.p. type are converted to floating-point format, such that \
the resulting floating-point output is of magnitude <input_value>+offset*\
scale.\n\n\nOptions / Csound\nDisplays an empty popup dialogue box. If csound \
is installed then entering the name of the executable ('csound' - without \
the quotes) into the box, pressing 'Ok', ensuring 'Options / System \
control / Save on exit' is set (depressed), then choosing 'File / Exit' \
ensures that the executable name (and path, if you need to specify it) is \
written to the MixwaveResources resource file in your home directory, where \
it is preserved. On next running mixwave, there will be further options under \
'Options / Csound' allowing sample and control rate information to be passed \
to Csound when it is invoked by mixwave (Csound is used for spatialisation).\
\n\nOptions / Csound / Wave samples\nPops up a dialogue box into which the \
sample rate used (the csound 'srate') in producing its output can \
be entered.\n\nOptions / Csound / Control rate\nPops up a dialogue box \
allowing entry of a value governing the size of batches of wave samples \
processed by csound per control period (the csound 'krate').");

	_edit->setEditStatus ( False );
}


void OptionsHelpCmd::okCallback ( XtPointer clientData, char * text )
{
	OptionsHelpCmd *obj = ( OptionsHelpCmd * ) clientData;

	obj->ok( clientData );	// ok mapped to 'enter'
}


void OptionsHelpCmd::cancelCallback ( XtPointer clientData )
{
	OptionsHelpCmd *obj = ( OptionsHelpCmd * ) clientData;

	obj->ok( clientData );	// call ok to delete object
}


void OptionsHelpCmd::ok ( void *clientData )
{
	OptionsHelpCmd *obj = ( OptionsHelpCmd * ) clientData;

	if (obj->_editRealised == TRUE )
	{
		obj->_editRealised = FALSE;
		delete obj->_edit;
	}
}
