/*
	RunCsoundCmd.cc

	Will 18, 2001: will@opaline.demon.co.uk
*/

#include "OpResources.h"
#include "RunCsoundCmd.h"
#include <WorkingDialogManager.h>
#include <FileAccess.h>
#include "MixwaveUtils.h"
#include "NewSpatialTemplateCmd.h"


RunCsoundCmd::RunCsoundCmd ( char *name, int active, char *baseName, float waveDuration ) : BreakCmd ( name, active )
{
	_baseName = baseName;
	_utils = new MixwaveUtils;
	_error[0] = 0;
	_line[0] = 0;
	_once = 0;

	strncpy ( _csndLog, baseName, sizeof ( _csndLog ) );
	_csndLog [ sizeof ( _csndLog ) - 1 ] = 0;
	strncat ( _csndLog, "_csoundRun.log", sizeof ( _csndLog ) - strlen ( _csndLog ) - 1 );
	_csndLog [ sizeof ( _csndLog ) - 1 ] = 0;

	strncpy ( _pidLog, _baseName, sizeof ( _pidLog ) );
	_pidLog [ sizeof ( _pidLog ) - 1 ] = 0;
	strncat ( _pidLog, "_", sizeof ( _pidLog ) - strlen ( _pidLog ) - 1 );
	_pidLog [ sizeof ( _pidLog ) - 1 ] = 0;		
	strncat ( _pidLog, mixwaveResources->csoundPidlogFile(), sizeof ( _pidLog ) - strlen ( _pidLog ) - 1 );
	_pidLog [ sizeof ( _pidLog ) - 1 ] = 0;

	strncpy ( _pidCmd, mixwaveResources->pidofCmd(), sizeof ( _pidCmd ) );
	_pidCmd [ sizeof ( _pidCmd ) - 1 ] = 0;
	strncat ( _pidCmd, " ", sizeof ( _pidCmd ) - strlen ( _pidCmd ) - 1 );
	_pidCmd [ sizeof ( _pidCmd ) - 1 ] = 0;
	strncat ( _pidCmd, mixwaveResources->csoundCmd(), sizeof ( _pidCmd ) - strlen ( _pidCmd ) - 1 );
	_pidCmd [ sizeof ( _pidCmd ) - 1 ] = 0;
	strncat ( _pidCmd, " > ", sizeof ( _pidCmd ) - strlen ( _pidCmd ) - 1 );
	_pidCmd [ sizeof ( _pidCmd ) - 1 ] = 0;
	strncat ( _pidCmd, _pidLog, sizeof ( _pidCmd ) - strlen ( _pidCmd ) - 1 );
	_pidCmd [ sizeof ( _pidCmd ) - 1 ] = 0;

	updateTimeout ( 250 );	// cycle pixmap interval 250 msec
}


RunCsoundCmd::~RunCsoundCmd()
{
	delete _utils;
}


void RunCsoundCmd::doCommand()
{
	if ( ! _once )
	{
		char removeFile [ strlen ( _pidLog ) + strlen ( mixwaveResources->removeCmd() ) + 2 ];
	
		strncpy ( removeFile, mixwaveResources->removeCmd(), sizeof ( removeFile ) );
		removeFile [ sizeof ( removeFile ) - 1 ] = 0;
		strncat ( removeFile, " ", sizeof ( removeFile ) - strlen ( removeFile ) - 1 );
		removeFile [ sizeof ( removeFile ) - 1 ] = 0;
		strncat ( removeFile, _pidLog, sizeof ( removeFile ) - strlen ( removeFile ) - 1 );
		removeFile [ sizeof ( removeFile ) - 1 ] = 0;

		FileAccess *check = new FileAccess ( removeFile, "r" );
		
		if ( check->errNum() == 0 )
			_utils->sysCall ( removeFile );

		delete check;

		char orcFile [ strlen ( _baseName ) + strlen ( mixwaveResources->cspatialOrchSuffix() ) + 1 ];
		char scoFile [ strlen ( _baseName ) + strlen ( mixwaveResources->cspatialScoreSuffix() ) + 1 ];
		char outFile [ strlen ( _baseName ) + 14 ];
		
		strncpy ( orcFile, _baseName, sizeof ( orcFile ) );
		orcFile [ sizeof ( orcFile ) - 1 ] = 0;
		strncpy ( scoFile, _baseName, sizeof ( scoFile ) );
		scoFile [ sizeof ( scoFile ) - 1 ] = 0;
		strncpy ( outFile, _baseName, sizeof ( outFile ) );
		outFile [ sizeof ( outFile ) - 1 ] = 0;

		strncat ( orcFile, mixwaveResources->cspatialOrchSuffix(), sizeof ( orcFile ) - strlen ( orcFile ) - 1 );
		orcFile [ sizeof ( orcFile ) - 1 ] = 0;
		strncat ( scoFile, mixwaveResources->cspatialScoreSuffix(), sizeof ( scoFile ) - strlen ( scoFile ) - 1 );
		scoFile [ sizeof ( scoFile ) - 1 ] = 0;
		// RawToWavCmd is invoked on the raw output
		strncat ( outFile, "_spatial.raw ", sizeof ( outFile ) - strlen ( outFile ) - 1 );
		outFile [ sizeof ( outFile ) - 1 ] = 0;

		char buf [ strlen ( scoFile ) + strlen ( orcFile ) + strlen (
					mixwaveResources->csoundCmd() ) + strlen (
					mixwaveResources->csoundRunFlags() ) +
					strlen ( outFile ) + 2*strlen ( _baseName ) + 40 ];

		strncpy ( buf, mixwaveResources->csoundCmd(), sizeof ( buf ) );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, " ", sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, mixwaveResources->csoundRunFlags(), sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, " ", sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, outFile, sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, orcFile, sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, " ", sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, scoFile, sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, " 2>", sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, _baseName, sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;
		strncat ( buf, "_csoundRun.log &", sizeof ( buf ) - strlen ( buf ) - 1 );
		buf [ sizeof ( buf ) - 1 ] = 0;

		_utils->sysCall ( buf );
	}

	if ( _once )
	{
		_utils->sysCall ( _pidCmd );

		FileAccess *checkPid = new FileAccess ( _pidLog, "r" );

		if ( checkPid->errNum() == 0 )
		{
			checkPid->readF ( _pidString, sizeof ( _pidString ) );
			_pidString [strlen ( _pidString ) - 1] =  0; 

			if ( strlen ( _pidString ) == 0 )
			{
				_done = True;

				if ( strstr ( _line, "error" ) != NULL )
				{
					strncpy ( _error, _line, sizeof ( _error ) );
					_error [ sizeof ( _error ) - 1 ] = 0;
				}
			}
		}	
		else
		{
			strncpy ( _error, checkPid->error(), sizeof ( _error ) );
			_error [ sizeof ( _error ) - 1 ] = 0;
			_done = True;
		}
	
		delete checkPid;
	}
	else
		_once = 1;

	if ( _done == TRUE )
		_once = 0;
}
