/*
    ViewWindowSizeCmd.cc
 
    Will Eighteen, 2000: will@opaline.demon.co.uk             
*/

#include "ViewWindowSizeCmd.h"
#include "Application.h"
#include <LineEdit.h>
#include <InfoDialogManager.h>
#include "OpResources.h"	// this is the only resources file with global resources

ViewWindowSizeCmd::ViewWindowSizeCmd ( const char *name, int active ) :  Cmd ( name, active )
{
	_popupRealised = False;
}


void ViewWindowSizeCmd::doCommand()
{
	if ( _popupRealised == True )
		return;

	char buf[30];
	
	_edit = new LineEdit ( ( char * ) name(), TRUE,
									&ViewWindowSizeCmd::enterCallback,
									&ViewWindowSizeCmd::cancelCallback, ( void * ) this );
                
	/* retrieve resource to be displayed */
 	snprintf ( buf, sizeof ( buf ), "%s", mixwaveResources->viewWindowSize());
	buf [ sizeof ( buf ) - 1 ] = 0;
	_edit->setColumns ( strlen ( buf ) );	// set width before instantiation
	_edit->setHelp ( "View window size hint to window manager; default 200x80" );
	_edit->execute();
	_edit->setText ( buf );	// can't set text before instantiation...
	_popupRealised = True;
}


void ViewWindowSizeCmd::undoCommand()
{
	// not implemented
}


void ViewWindowSizeCmd::enterCallback ( void *clientData, char *text )
{
	char buf[256];
	
	ViewWindowSizeCmd *obj = ( ViewWindowSizeCmd * ) clientData;

	if ( strcmp ( text, mixwaveResources->viewWindowSize() ) != 0 )
	{
		strncpy ( buf, text, sizeof ( buf ) );
		buf [ sizeof ( buf ) - 1 ] = 0;
		obj->enter ( buf );
	}

	obj->_popupRealised = False;
	delete obj->_edit;
}


void ViewWindowSizeCmd::enter ( char *text )
{
	unsigned int i = 0;

	while ( i < strlen ( text ) )
	{
		if ( ( text[i] < 48 ) || ( text[i] > 57 ) )	// not a digit
			if ( text[i] != 'x' )
			{
				infoDialogManager->post ( "Error in input, expecting 'HxW', Height, Width" );
				return;
			}
			
		i++;
	}
		
	mixwaveResources->viewWindowSize ( text );
}


void ViewWindowSizeCmd::cancelCallback ( void *clientData )
{
	ViewWindowSizeCmd *obj = ( ViewWindowSizeCmd * ) clientData;

	obj->_popupRealised = False;
	delete obj->_edit;
}
