/*
 CmdInterface.cc - Cmd interface class implementation

 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/

#include "CmdInterface.h"
#include "Cmd.h"


CmdInterface::CmdInterface ( Cmd *cmd ) : Interface ( cmd->name() )
{
	_active = TRUE;
	_cmd = cmd;
	
	cmd->registerInterface ( this );
}


void CmdInterface::executeCmdCallback ( Widget, XtPointer clientData, XtPointer )
{
	CmdInterface *obj = ( CmdInterface * ) clientData;
	obj->_cmd->execute();
}


void CmdInterface::activate()
{
	if ( _w )
		XtSetSensitive ( _w, TRUE );
	
	_active = TRUE;
}


void CmdInterface::deactivate()
{
	if ( _w )
		XtSetSensitive ( _w, FALSE );
		
	_active = FALSE;
}

