/*
 MessageDialogManager.cc - MessageManagerDialog class implementation

 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/

#include "MessageDialogManager.h"
#include <Xm/Xm.h>
#include <Xm/MessageB.h>

// define global instance
MessageDialogManager *messageDialogManager = new MessageDialogManager ( "MessageDialog" );


Widget MessageDialogManager::createDialog ( Widget parent )
{
	Widget dialog = XmCreateMessageDialog ( parent, _name, NULL, 0 );
	
	// clear the '*_popup' window title (for multiple use as query, info, ...)
	XmString xmstr = XmStringCreateSimple ( "" );   
	
	XtVaSetValues ( dialog, XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
			XmNdialogTitle, xmstr, NULL );

	XmStringFree ( xmstr );
	return ( dialog );
}

	
/*
  Notes:
  
  The createDialog() method returns a MessageDialog widget each time it is
  called; the dialog style is 'full application modal', i.e it does not process
  device events for widgets other than those in the dialog. This simulates
  blocking, forcing the Message tobe answered. Applications can modify this
  behaviour by changing the XmNdialogStyle resource value of the widget returned
  by post()
*/
