/*
 MenuWindow.h - add a MenuBar to the MainWindow features

 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/


#ifndef MENUWINDOW_H
#define MENUWINDOW_H


#include "MainWindow.h"

class MenuBar;


class MenuWindow : public MainWindow
{
	public:
		MenuWindow ( const char *name );
		virtual ~MenuWindow();
		
	protected:
		MenuBar *_menuBar;
		virtual void initialize();
		virtual void createMenuPanes() = 0;
};

#endif

/*
  Notes:
  
  MainWindow is useful where only a work area is required; if menus are required,
  this adds a bar to the top of the work area.
*/
